#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <sys/time.h>

int mestre();
int escravo();

int numeroAleatorio()
{
    int res=rand()%1000;
}

int rank, size, maiorLocal, maiorGlobal;
int vetor[1000];

int main(int argc, char *argv[])
{
  MPI_Status st;


  srand(time(0));
  
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  
  if (rank == 0)
     mestre();
  else
     escravo();
  
  MPI_Finalize();
  return 0;
}

int mestre()
{
    //inicializar o vetor
    int i;
//    int maiorLocal, maiorGlobal;
    for(i=0;i<1000;i++)
       vetor[i]=numeroAleatorio();
       
    MPI_Bcast(vetor,1000,MPI_INT,0,MPI_COMM_WORLD);
    //procurar maiorLocal
    maiorLocal=0;
    for(i=0;i<1000/size;i++)
    {
        if (vetor[i] > maiorLocal)
           maiorLocal = vetor[i];               
    }
    printf("Processo 0 - maiorlocal = %d\n",maiorLocal); fflush(stdout);
    maiorGlobal = maiorLocal;
    MPI_Reduce(&maiorLocal,&maiorGlobal,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD);
    printf("Maior global = %d\n", maiorGlobal);fflush(stdout);
    return 1;
}

int escravo()
{
    int i,inicio,fim;
    
    MPI_Bcast(vetor,1000,MPI_INT,0,MPI_COMM_WORLD);
    inicio = (1000/size)*rank;
    fim = (1000/size)*(rank+1);
    maiorLocal=0;
    for(i=inicio;i<fim;i++)
    {
      if (vetor[i]>maiorLocal)
         maiorLocal = vetor[i];
    }
      
    printf("Processo %d - maiorlocal = %d\n",rank, maiorLocal);fflush(stdout);
    MPI_Reduce(&maiorLocal,&maiorGlobal,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD);
    return 1;

    
}
