/*

   programa que vai fazer o seguinte: 
   abordagem mestre-escravo: 
    
     mestre monta uma matriz dinmica de x linhas por 10 colunas
     
     a quantidade de linhas  montada de acordo com o nmero de escravos
     
     para n = 5 processos - 1 mestre e 4 escravos
     
     1 1 1 1 1 1 1 1 1.... --> linha vai para o escravo 1
     2 2 2 2 2 2 2 2 2.... --> linha vai para o escravo 2
     3 3 3 3 3 3 3 3 3.... --> linha vai para o escravo 3
     4 4 4 4 4 4 4 4 4.... --> linha vai para o escravo 4
     
     cada escravo recebe e imprime sua linha
     
     



*/


#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char *argv[])
{
  int *matriz;
  int numproc, id, i, j;
  
  MPI_Status st;
  
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD,&numproc); // quantos processos existem
  MPI_Comm_rank(MPI_COMM_WORLD,&id);      // qual a identificao da cpia em questo
  
  if (id == 0) // sou o mestre
  {
     // passo 1 alocar e popular a matriz
     matriz = (int*) malloc(sizeof(int)*(numproc-1)*10);
     for (i=0;i<(numproc-1);i++)
     {
         for(j=0;j<10;j++)
         {
            *(matriz+(i*10+j)) = i+1;
         }
     }
     
     // passo 2 - enviar para cada um dos escravos
     
     for(i=1;i<numproc;i++)
     {
         printf("Mestre - mandando a submatriz para o processo %d\n",i); fflush(stdout);
         MPI_Send(matriz+(i-1)*10, 10, MPI_INT, i, 0, MPI_COMM_WORLD);
     }
  }
  else // sou o escravo
  {
      matriz = (int*) malloc(sizeof(int)*10);
      
      MPI_Recv(matriz, 10, MPI_INT, MPI_ANY_SOURCE, 0, MPI_COMM_WORLD, &st);
      printf("Processo %d - ",id);
      for (i=0;i<10;i++)
      {
         printf("%2d", *(matriz + i));
      }
      printf("\n");fflush(stdout);
      fflush(stdout);
      
  }
    
  MPI_Finalize();
  
  //system("PAUSE");	
  return 0;
}
