#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define REQ 1
#define REP 2
#define OFFSET 5

int main(int argc, char *argv[])
{
  int nproc, rank, i, inicio;
  MPI_Status st;
  double *vet, total, parcial;
  double ini,fim;
  
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD, &nproc);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
  if (rank == 0) // mestre
  {
     printf("Processo mestre - Total = %d\n",nproc); fflush(stdout);
     vet = (double*) malloc(sizeof(double)*nproc);
     ini = MPI_Wtime();
     for (i=1;i<nproc;i++)
     {
         inicio = (i-1)*OFFSET+1;
         printf("Enviando %d para %d\n",inicio,i); fflush(stdout);
         MPI_Send(&inicio, 1, MPI_INT, i, REQ, MPI_COMM_WORLD);
     }
     total=0.0;
     for (i=1;i<nproc;i++)
     {
         MPI_Recv(&vet[i], 1, MPI_DOUBLE, i, REP, MPI_COMM_WORLD, &st);
         total+=vet[i];
     }
     fim = MPI_Wtime();
     printf("Total da somatoria = %lf\n",total); fflush(stdout);
     printf("Tempo de execucao = %lf\n",fim-ini); fflush(stdout);
  }
  else // escravo
  {
     MPI_Recv(&inicio, 1, MPI_INT, 0, REQ, MPI_COMM_WORLD, &st);
     parcial=0.0;
     for (i=inicio; i<inicio+OFFSET;i++)
        parcial+=1.0/i;
     printf("Escravo - %d - Parcial = %lf\n",rank,parcial);
     MPI_Send(&parcial, 1, MPI_DOUBLE, 0, REP, MPI_COMM_WORLD);
  }
  MPI_Finalize();
  return 0;
}
